package
{
	import flash.display.Bitmap;
	import flash.geom.Point;
	import flash.ui.Mouse;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class GameState extends FlxState
	{
		[Embed(source = "data/map.png")] public static var ImgMap:Class;
		[Embed(source = "data/bed.png")] public static var ImgBed:Class;
		[Embed(source = "data/doctor.png")] public static var ImgDoctor:Class;

		[Embed(source = "data/level1.txt", mimeType="application/octet-stream")] public static var Level1:Class;
//		[Embed(source = "data/bg.png")] private var BgImg:Class;
//		[Embed(source = "data/woman.png")] private var ImgWoman:Class;
		[Embed(source = "data/music.mp3")] public static var SndMusic:Class;
//		[Embed(source = "data/sound.mp3")] public static var SndSound:Class;
//		[Embed(source = "data/gameover.mp3")] public static var SndGameover:Class;

		public var player:Player;
		public var flowers:FlxGroup;
		public var endDoor:EndDoor;
		public var openflowers:FlxGroup;
		public var others:FlxGroup;
		public var tilemap:FlxTilemap;
		public var collisionGroup:FlxGroup;
		public var spikes:FlxGroup;
		
		public var beds:FlxGroup;
		public var doctors:FlxGroup;
		
		public var texts:Array = [
			"Don't fear god",
			"Don't worry about death",
			"What is good is easy to get",
			"What is terrible is easy to endure"
		]
		public var index:int;
		
		override public function create():void
		{
			index=-1;
			this.collidedBefore=false;
			beds = new FlxGroup();
			doctors = new FlxGroup();
			this._time=0;
			spikes = new FlxGroup();
			collisionGroup = new FlxGroup();
			
			
			// generate map
			var levelStr:String = "";

			var m:Bitmap = new ImgMap();
			for (var j:int=0;j<m.bitmapData.height;j++)
			{
				if (j>0)
					levelStr+="\n";
				
				for (var i:int=0;i<m.bitmapData.width;i++)
				{
					if (m.bitmapData.getPixel32(i,j)==0xff000000)
					{
						levelStr+="0";						
					}
					else if (m.bitmapData.getPixel32(i,j)==0xffffffff)
					{
						levelStr+="1";
					}
					else if (m.bitmapData.getPixel32(i,j)==0xffff0000)
					{					
						levelStr+="0";
						var s:FlxSprite = new FlxSprite(i*8,j*8-4);
						s.fixed=true;
						s.loadGraphic(ImgBed,false,true);
						beds.add(s);
					}
					else if (m.bitmapData.getPixel32(i,j)==0xff00ff00)
					{
						levelStr+="0";
						s = new FlxSprite(i*8,j*8-8);
						s.fixed=true;
						s.loadGraphic(ImgDoctor,false,true);
						beds.add(s);						
					}
					else if (m.bitmapData.getPixel32(i,j)==0xff0000ff)					
					{						
						levelStr+="0";
						player = new Player(i*8,j*8-4);
					}
					else
					{
						levelStr+="0";
					}
					
					if (j>0)
						levelStr+=",";
					
				}
				
			}
		
			tilemap = new FlxTilemap();
			tilemap.auto=FlxTilemap.AUTO;
			tilemap.loadMap(levelStr,FlxTilemap.ImgAuto,8,8);
			this.add(tilemap);
			
			flowers = new FlxGroup();
			this.add(flowers);
			
			openflowers = new FlxGroup();
			this.add(openflowers);
			
			others = new FlxGroup();
			this.add(others);			
			
			
			
			this.add(beds);
			this.add(doctors);
							this.add(player);
							FlxG.follow(player);
							
			
			collisionGroup.add(player);
			collisionGroup.add(tilemap);
			collisionGroup.add(beds);
			collisionGroup.add(doctors);
			//player = new Player();
			
			
			hudText = new FlxText(0,0,300,"");
			hudText.color=0xff00ff00;
			hudText.alignment="center";
			hudText.visible=false;
			this.add(hudText);
		}
		
		public function collectFlower(p:FlxSprite,f:FlxSprite):void
		{
			var _p:Player = p as Player;
			/*if (_p.hasFlower==false)
			{
				_p.hasFlower=true;
				_p.play("idleflower",true);
				f.kill();
			}*/
			
		}
		
		public function overlapOther(p:FlxSprite,o:FlxSprite):void
		{
			var _p:Player = p as Player;
			/*if (_p.hasFlower==true)
			{				
				_p.hasFlower=false;
				_p.play("idle",true);
				o.solid=false;
				o.play("bop",true);
				var openfl:OpenFlower = new OpenFlower(o.x+9,o.y);
				openflowers.add(openfl);
			}*/
			
		}
		
		public var _time:Number;
		
		
		public var collidedBefore:Boolean;
		
		public var hudText:FlxText;
		
		public function generateNewText():void
		{
			
		}
		
		override public function update():void
		{
			
			//collisionGroup.collide();
			
			var oldCollided:Boolean=collidedBefore;
			
			collidedBefore = FlxU.collide(this.player,this.tilemap);
			collidedBefore = collidedBefore || FlxU.collide(this.player,beds);
			collidedBefore = collidedBefore || FlxU.collide(this.player,doctors);
			
			hudText.visible=true;
			
			_time+=FlxG.elapsed;
			
			if (_time>4)
			{
				index=(index+1)%4;
				hudText.text=texts[index];
				_time=0;
			}
	
			hudText.x=player.x-150+6;
			hudText.y=player.y-20;
			super.update();
			
			if (player.y>20*28)
			{
				FlxG.state = new GameState();
			}
		}
	}
}